#pragma once

#include <vector>
#include <memory>

class MarkdownElement;
class MarkdownLink;

class MarkdownDocument
{
public:
    void addElement(std::unique_ptr<MarkdownElement> element);

    std::size_t getNumElements() const;

    MarkdownElement* getElement(std::size_t idx) const;

    void doLinkTargetSubstitution(const std::string& targetString, const std::string& replacementString);

    std::vector<MarkdownLink*> getAllLinks() const;

private:
    std::vector<std::unique_ptr<MarkdownElement> > mElements;
};


